 

 #define Version "13-03-2016"
 
 // recherche de "OK" dans le buffer2  via strpbrk
 // est bien plus fiable que strstr ou strncmp
 // TMR0 ne reagit paas en High interrupt si utlis dans subroutine
 // => usage de TMR1 IT en LOw interrupt
  // meme probleme !
 
 // correctif sur void LCD_Write_Chr_At(int Ligne,int col,char c1)
 // avec alim 3,3V le LCD 4x20 @0x4E ne fonctionne plus
 // donc usage du LCD2119 @ 0x74=116
 // sur bus I2C1  RC3=SCL  et RC4=SDA
  //ac:Pinout_18F46K22
 
  //ac:AT_cdes
  
  
// Project : WIFI3_18F46k22_UART1_LCD2119_3_3V.mcppi
// source :  18F46k22_UART1_LCD2119_3_3V_160311.c
// EEPROM :  18F46k22_UART1_LCD4x20_I2C2_EEPROM.ihex
// Mikroc V 6.62
// PIC18F46K22  3,3
// FOSC=Q=10MHz

// UART RC6 RC7 ->Interface Prolific LTTL/USB  -> COM12 19200  -> PC XP  VBray 2014
// UART , C_String   C_Stdlib   Conversions , I2C
// EEPROM :   18F46K22_Uart1_LCD2119_3_3V_160311.ihex

/* Config bit  : P18F46K22_Q10Mhz_NoPLL.cfgsch
CONFIG1H : $300001 : 0x0023
CONFIG2L : $300002 : 0x001E
CONFIG2H : $300003 : 0x003C
CONFIG3H : $300005 : 0x0099
CONFIG4L : $300006 : 0x0080
CONFIG5L : $300008 : 0x000F
CONFIG5H : $300009 : 0x00C0
CONFIG6L : $30000A : 0x000F
CONFIG6H : $30000B : 0x00E0
CONFIG7L : $30000C : 0x000F
CONFIG7H : $30000D : 0x0040
CONFIG7H : $30000D : 0x0040

 hardware
I2C2      SCL sur RD0
I2C2      SDA sur RD1
I2C1      SCL sur RC3
I2C1      SDA sur RC4
TX        UART1 sur RC6
RX        UART1 sur RC7
RA0       Entree Analog
RA4       Sortie Led rouge

*/

#include "built_in.h"     // for  Hi  Lo ..etc

#define PROCESSOR 18F46K22
#define POWER_SUPPLY_3_3V
#define FOSC 10.0  // MHz
#define BAUD 19200  // UART1
#define CLS 12
#define CR 13
#define LF 10
#define TAB 9
#define BACK 8
#define Separator 0x20   // space

//#define LCD_ADDR 0x4E     // LCD Bleu 4x20 PCF8574 on pigboard YwRobot back located  en 5V seulement !
#define LCD_ADR 0x74     // LCD 2119 2x16 car  OK avec alim 3,3V

// LCD Command
#define LCD_CLEAR 0x01
#define LCD_HOME  0x02
#define Display_ON 0x0C
#define Display_OFF 0x08
#define LCD_LINE1 0x80      // 0x00 + bit D7=1 
#define LCD_LINE2 0xC0      // 0x40 + bit D7=1 
//#define LCD_LINE3 0x94      // 0x14 + bit D7=1
//#define LCD_LINE4 0xD4      // 0x54 + bit D7=1

#define NbCycles_T1 8       // nb d'interrupot pour faire 1 seconde

sbit Led_Rouge at LATA5_bit;
 // module connections  click#1
sbit CH_PD  at LATA2_bit;      // resert pin
sbit GPIO15 at LATA4_bit;
sbit CH_PD_Direction  at LATA2_bit;
sbit GPIO15_Direction at LATA4_bit;

const code char mesg0[]="Mikroc 6.62 18F46K22 LCD2x16 I2C1 "Version"\n\r";
const code char mesg1[]="                    ";
const code char * Messages[]={mesg0,mesg1};

#define MAXLEN2 200
volatile unsigned char buffer1[MAXLEN2];
volatile int Flag_Buffer1;
volatile  unsigned char c1;  
volatile unsigned int i1; 
volatile int Index1;
volatile unsigned int CptErr;
#define MAXLEN1 200
volatile unsigned char buffer2[MAXLEN1];
volatile int Flag_Buffer2;
volatile  unsigned char c2;
volatile unsigned int i2;
volatile int Index2;
volatile int Vbray;


char received_data[16], ip_address[16];
//unsigned char tmp;
int UART2_DataReady;

unsigned char Step;

// Change following information to match your network settings
unsigned char SSID[]={ "ESP_8266W3"};
unsigned char password[] ={"      "};
unsigned char port[] ={"10001"};

static int Flag_Timer1;
static int Cpt1;
static int Max_Timer1;


int i,j,k,l,m;
unsigned  char TEXTE[64];
unsigned char * txt;
unsigned char *p;
char CRam1[32];   // for flot2asccii use
//char CRam2[32];   // for flot2asccii use
char Tampon[35];
unsigned int EAnx,EAn0,EAn1;
unsigned int SEAn0,SEAn1;
int nM;
unsigned char N1;
unsigned char  addr,donnee;
unsigned int Etat;
 
float f1,f2,ff;
         
extern void Tempo_500uS(void);
extern  void Tempo_1mS(void);

void Init_Hardware(void) ;
void Read_Msg_Eeprom( int depuis);
void Write_Msg_Eeprom( int Adr,const char * d1) ;

void Init_Timer1 (void);    //125mS
void CRLF1(void) ;
void UART1_Write_CText(const char *txt); 
void RAZ_UART1(void);
void CRLF2(void) ;
void UART2_Write_CText(const char *txt) ;
void RAZ_UART2(void);

void strConstRamCpy(unsigned char *dest, const code char *source);
unsigned char *Float2Ascii (float x, unsigned char *chaine,char precision) ;
unsigned short Dec2Bcd(unsigned short decnum);



void LCD_CLS(void);
void LCD_Clear(void); // <-- PB >> au lieu de space..  suivre
int LCD2119_Init(void);
void LCD_RAZ_Ligne(int L);
void LCD_Write_Chr_At(int Ligne,int Col,char c1) ;
void LCD_Write_Text_At(unsigned int Ligne,unsigned int col,char * t1);
void LCD_Write_CText_At(unsigned int Ligne,unsigned int col,const char * t1);
void LCD_Write_CText(const char * t1);
void Cree_Euro(void) ;
void Cree_8_cars_CGRAM(void)  ;
void LCD_Cde(unsigned char Cde);
void LCD_Gauche(void);
void LCD_Droite(void);
unsigned char check_device(unsigned char dev_address);  // necessite liaison RS232 UART1

void Re_test(void);
void TEST(void);

void Interrupts() iv 0x0008 ics ICS_AUTO
{

//  UART2
    if((RC2IF_bit==1) && (RC2IE_bit==1))
    {
       c2 =RCREG2;  //UART2_Read();

        if(OERR2_bit)
        {
          CREN2_bit = 0;
          CREN2_bit = 1;
          OERR2_bit = 0;
           c2 = RCREG2;
        }
        if(FERR2_bit==1)   c2 = RCREG2;

        if (  (Vbray==1)  && (  (c2==LF)|| (c2==CR))  )
         {
              Flag_Buffer1=1;
              if (i2 > MAXLEN2-2) Flag_Buffer1=2;
              i2--;
              RC2IE_bit=0 ; //interdit IT Reception UART
               buffer2[i2]=0;
               Index2=i2;
               i2=0;
               c2=0;
          }
           else
          {
               if (i2 > MAXLEN2-2)
               {
                Flag_Buffer2=2;
                i2--;
                RC2IE_bit=0 ; //interdit IT Reception UART
                buffer2[i2]=0;
                }
                else
                {
               // if(c2>0)
               //  {
                   buffer2[i2]=c2;
                   Index2=i2;
                   i2++;
               //   }
               }
           }
      }
 if ( (RCIE_bit) && ( RCIF_bit))
   {
   // traitement separe des erreurs de COM
      c1 = RCREG;
      if (RCSTA.OERR==1)    // voir parag 16.1.26 p273
      {
       RCSTA.CREN = 0 ;
       c1 = RCREG;
       RCSTA.CREN = 1 ;
        CptErr++;

       }
      if(RCSTA.FERR==1 )
      {
      RCSTA.SPEN = 0 ;
      RCSTA.SPEN= 1 ;
      CptErr++;
       c1 = RCREG;
      }
     if ((c1==CR) || (i1 > MAXLEN1-2))
      {
      Flag_Buffer1=1;
      PIE1.RCIE=0 ; //interdit IT Reception UART
      buffer1[i1]=0;
      Index1=i1;
      i1=0;
      c1=0;
     }
     else
     {
        if (i1 > MAXLEN1-2)  Flag_Buffer1=2;
        buffer1[i1]=c1;
        Index1=i1;
        i1++;

      }
   }
 }
 
 
 
 
void Interrupt_LOW() iv 0x0018 ics ICS_AUTO
 {

  // -----  timer 1  ----------------
  if  ( (TMR1IE_bit==1) && ( TMR1IF_bit==1))
   {  // Test "Peripheral Interrupt Request Register 1" for Timer1 Flag
     Cpt1++;
     if (Cpt1 >=Max_Timer1)   // x100 ms
       {
        Cpt1=0;
        Flag_Timer1=1;
        TMR1ON_bit=0;
        TMR1IE_bit=0;
      }
      TMR1H= 0x0B; // Hi (3035);
      TMR1L= 0xDB; // Lo (3035);
      PIR1.TMR1IF=0;
   }
 }


// *** LCD 2119   2x16 car sur bus I2C  ***********


void LCD_CLS()
{
// d'abord la ligne 2 pour avoir le curseur en 0 de ligne 1
LCD_RAZ_Ligne(2);
LCD_RAZ_Ligne(1);
}


void LCD_Clear()
{
 // problematique car CGM type R
int j;
I2C1_Start();
j=I2C1_Wr(LCD_ADR); // i2c slave Address
j=I2C1_Wr(0x00);
j=I2C1_Wr(0x24);
j=I2C1_Wr(0x06);
j=I2C1_Wr(0x02);
j=I2C1_Wr(0x01);
j=I2C1_Wr(0x40);
I2C1_Stop();
}

int LCD2119_Init(void)
{
// see datasheet PCF2119x NXP Semiconductorspage 69
int j,k;
k=0;
Delay_ms(500);
I2C1_Start();
j=I2C1_Wr(LCD_ADR); // i2c slave Address
if (j!=0) return k;
k++;
Delay_ms(200);
j=I2C1_Wr(0x00);    // Control byte for Instruction
if (j>0) return k;
k++;
I2C1_Wr(0x24); //0x20 +  DL=0 format 4 ou 8 bits not used, M=1 car 2x16 cars display, SL=0 1:18, H: mode standard
I2C1_Wr(0x0C); // D: Display on, C: curser off, B: blink off
I2C1_Wr(0x06); // Entry mode set : I/D: increment, S: no shift
I2C1_Wr(0x25); // DL: 8 bits, M: 16 by two line, SL: 1:18, H: extended instruction set
//I2C1_Wr(0x04); // P: left to right, Q: top to bottom    sur connecteur A
I2C1_Wr(0x06); // P: Right to left ,Q: top to bottom      sur connecteur B
I2C1_Wr(0x11); // TC1: 0, TC0: 1
I2C1_Wr(0x42); // HV Stages 3
//I2C1_Wr(0x9f); // set Vlcd, store to VA
I2C1_Wr(0x96); // set Vlcd, store to VA  (avec alim=3,3V)
j=I2C1_Wr(0x24); // DL: 8 bits, M: two line, SL: 1:18, H: normal instruction set
if (j>0) return k;
k++;
j=I2C1_Wr(0x0C);
if (j>0) return k;
k++;
j=I2C1_Wr(0x06);
if (j>0) return k;
k++;
j=I2C1_Wr(0x02); // return home
if (j>0) return k;
k++;
// avec LC2119 RU  remplissage avec caractere >> au lieu de blanc=espace
/// il faut un modele LCD2119 AU  !
j=I2C1_Wr(0x01); // clear display
if (j>0) return k;
Delay_ms(100);
I2C1_Stop();
k++;
return k;
}

void LCD_RAZ_Ligne( int L)
{  int i;
 I2C1_Start();
 I2C1_Wr(LCD_ADR); // i2c slave Address
 I2C1_Wr(0x00); // Control byte for Instruction
 I2C1_Wr(0x02); // return home
 switch (L)
 {
  case 1:
      I2C1_Wr(0x80); // DDRAM Address 1ere ligne
      break;
  case 2:
      I2C1_Wr(0xC0); // DDRAM Address 2em ligne
      break;
  default:
  break ;
 }
 I2C1_Repeated_Start();
 I2C1_Wr(LCD_ADR); // i2c slave Adress
 I2C1_Wr(0x40);     // Control byte for Data
 for (i=0;i<39;i++)
 {
   I2C1_Wr(0x80+32); // efface avec des blanc
 }
 // repositionne au debut de ligne
 I2C1_Repeated_Start();
 I2C1_Wr(LCD_ADR); // i2c slave Adress
 I2C1_Wr(0x00); // Control byte for Instruction
 //I2C1_Wr(0x40);     // Control byte for Data
 switch (L)
  {
   case 1:
         I2C1_Wr(0x80); // DDRAM Address 1ere ligne
        break;
   case 2:
        I2C1_Wr(0xC0); // DDRAM Address 2em ligne
        break;
   default:
        break ;
  }
 I2C1_Stop();
}


void LCD_Write_CText(const char * t1)
 {
  char TT[17];
  int i;
  strConstRamCpy(TT,t1);
  I2C1_Start();
  I2C1_Wr(LCD_ADR); // i2c slave Address
  I2C1_Wr(0x00); // Control byte for Instruction
 I2C1_Repeated_Start();
 I2C1_Wr(LCD_ADR); // i2c slave Adress
 I2C1_Wr(0x40); // Control byte for Data
 i=0;
 while(*(t1))
 {
  I2C1_Wr(0x80+*(t1));
  t1++;
  i++;
  if (i>16) break;
 }
 I2C1_Stop();
}


void LCD_Write_CText_At(unsigned int Ligne,unsigned int col,const char * t1)
 {
  char TT[17];
  int i;
  strConstRamCpy(TT,t1);
  I2C1_Start();
  I2C1_Wr(LCD_ADR); // i2c slave Address
  I2C1_Wr(0x00); // Control byte for Instruction
  if(col>16) col=16;
  switch (Ligne)
 {
  case 1:
      I2C1_Wr(0x80+col-1); // DDRAM Address 1ere ligne
      break;
  case 2:
      I2C1_Wr(0xc0+col-1); // DDRAM Address 2em ligne
        break;
  default:
  break ;
 }
 I2C1_Repeated_Start();
 I2C1_Wr(LCD_ADR); // i2c slave Adress
 I2C1_Wr(0x40); // Control byte for Data
 i=0;
 while(*(t1))
 {
  I2C1_Wr(0x80+*(t1));
  t1++;
  i++;
  if (i>16) break;
 }
 I2C1_Stop();
}



void LCD_Write_Chr_At(int Ligne,int col,char c1)
{ //.. ligne 1 ou 2
  //.. col de 1  16
  // .. Special =0 pour ascii normal   1 pour caracteres perso definis en CGRAM
  I2C1_Start() ;
  I2C1_Wr(LCD_ADR); // i2c slave Adress
  I2C1_Wr(0x00); // Control byte for Instruction
  if(col>16) col=16;
  switch (Ligne)
  {
  case 1:
      I2C1_Wr(0x80+col-1); // DDRAM Address 1ere ligne
      break;
  case 2:
      I2C1_Wr(0xc0+col-1); // DDRAM Address 2em ligne
      break;
  default:
      break ;
  }
  I2C1_Repeated_Start() ;
  I2C1_Wr(LCD_ADR); // i2c slave Address
  I2C1_Wr(0x40); // Control byte for Data
  I2C1_Wr(0x80+c1);
  Delay_ms(10);                      // Pause de 10ms
  I2C1_Stop();
 }

void LCD_Write_Text_At(unsigned int Ligne,unsigned int col,char * t1)
{ //.. ligne 1 ou 2
  //.. col de 1  16
  int i;
  I2C1_Start();
  I2C1_Wr(LCD_ADR); // i2c slave Address
  I2C1_Wr(0x00); // Control byte for Instruction
  if(col>16) col=16;
  switch (Ligne)
  {
  case 1:
      I2C1_Wr(0x80+col-1); // DDRAM Address 1ere ligne
      break;
  case 2:
      I2C1_Wr(0xc0+col-1); // DDRAM Address 2em ligne
      break;
  default:
      break ;
  }
  I2C1_Repeated_Start();
  I2C1_Wr(LCD_ADR); // i2c slave Adress
  I2C1_Wr(0x40); // Control byte for Data
  i=0;
  while(*(t1))
  {
  I2C1_Wr(0x80+*(t1));
  t1++;
  i++;
  if (i>16) break;
  }
  I2C1_Stop();
}

void LCD_Home()
{
 LCD_Cde(0x02);
}


void LCD_Droite()
{
  LCD_Cde(0x014);
 }

void LCD_Cde(unsigned char Cde)
{
 I2C1_Start();
 I2C1_Wr(0x76); //Display adress
 I2C1_Wr(0x00); //Register Select Config Register
 I2C1_Wr(Cde); //Write Data
 I2C1_Stop();
}

void LCD_Gauche()
{
  LCD_Cde(0x010);
 }

void Cree_8_cars_CGRAM()
{
unsigned char b1,b2;
int i,j;
 I2C1_Start();
 I2C1_Wr(LCD_ADR); // i2c slave Adress
 I2C1_Wr(0x00);
 // Cde Set_CGRAM address to 0  =>  (0x40 + adresse=0 )
 I2C1_Wr(0x40);
// I2C1_Start();
 I2C1_Repeated_Start() ;
 I2C1_Wr(LCD_ADR); // i2c slave Adress
 I2C1_Wr(0x40);// set CGRAM adress
 //Probleme : 5 pixels seulement accessibles en largeur (sur 8)
// blanc
I2C1_Wr(0b0000000);
I2C1_Wr(0b0000000);
I2C1_Wr(0b0000000);
I2C1_Wr(0b0000000);
I2C1_Wr(0b0000000);
I2C1_Wr(0b0000000);
I2C1_Wr(0b0000000);
I2C1_Wr(0b0000000);
  b2=32;
  b1=0;
  for (i=0;i<5;i++)
  {
   b2=b2>>1;
   b1=b1+b2;
   for (j=0;j<8;j++)
   {
   #ifdef With_UART
     UART1_Write_CText("I2C1_Wr(");
     Decompile_byte(b1);
     CRLF1();
     #endif
     I2C1_Wr(b1);

   }
   #ifdef With_UART
    CRLF1();
    #endif
  }
  // petit rectangle
I2C1_Wr(0b0000000);
I2C1_Wr(0b0000000);
I2C1_Wr(0b0011111);
I2C1_Wr(0b0010001);
I2C1_Wr(0b0011111);
I2C1_Wr(0b0000000);
I2C1_Wr(0b0000000);
I2C1_Wr(0b0000000);

// The Euro currency character can be recognized by the 0/1 pattern (see Figure 48)
I2C1_Wr(0x06); // 00110
I2C1_Wr(0x09); // 01001
I2C1_Wr(0x08); // 01000
I2C1_Wr(0x1E); // 11110
I2C1_Wr(0x1E); // 11110
I2C1_Wr(0x08); // 01000
I2C1_Wr(0x09); // 01001
I2C1_Wr(0x06); // 00110
I2C1_Stop();
}


void Cree_Euro()
{
I2C1_Start();
// PCF2119 slave address for write, SA0 is connected to Vdd
I2C1_Wr(LCD_ADR); // i2c slave Adress
// MSB (Continuation bit Co) = 0, more than one byte may follow. Bit6, RS=0, next byte
// is command byte
I2C1_Wr(0x00);
// 2 lines x 16, 1/18 duty, basic instruction set. Next byte will be another command.
//I2C1_Wr(0x24);
I2C1_Wr(0x06); // Entry mode set : I/D: increment, S: no shift
//I2C1_Wr(0xC0);  // DDRam adresse remark page 35
// Cde Set_CGRAM address to 0  =>  (0x40 + adresse=0 )
I2C1_Wr(0x40);
//I2C1_Stop();
// Repeated Start condition
 I2C1_Repeated_Start() ;
I2C1_Wr(LCD_ADR); // i2c slave Adress
// RS=1, next byte is a data byte
I2C1_Wr(0x40);// set CGRAM adress
// Here the data bytes to define the character
// Behind the write commands the 5x8 dot matrix is shown, the 1 represents a on pixel.
// The Euro currency character can be recognized by the 0/1 pattern (see Figure 48)
I2C1_Wr(0x06); // 00110
I2C1_Wr(0x09); // 01001
I2C1_Wr(0x08); // 01000
I2C1_Wr(0x1E); // 11110
I2C1_Wr(0x1E); // 11110
I2C1_Wr(0x08); // 01000
I2C1_Wr(0x09); // 01001
I2C1_Wr(0x06); // 00110
I2C1_Stop();
}


unsigned char check_device(unsigned char dev_address)
{
char Etat;
strConstRamCpy(txt,"Device at adresse : ");
k=strlen(txt);
ByteToStr(dev_address,CRam1);
strcat(txt+k,CRam1);
UART1_Write_Text(txt);
I2C1_Start();
if(I2C1_Wr(dev_address)!=0 )
 {
  UART1_Write_CText(" is not found\r\n");
  Etat=0;
 }
 else
 {
  UART1_Write_CText(" found OK\r\n");
  Etat=1;
  }
I2C1_Stop();
 return Etat;
}




// --- Copie le texte depuis FLASH ROM vers RAM
void strConstRamCpy(unsigned char *dest, const code char *source)
 {
  while (*source)*dest++ = *source++ ;
  *dest = 0 ;    // terminateur
}



void CRLF1()
{
 UART1_Write(CR);
 UART1_Write(LF);
}

void UART1_Write_CText(const char *txt)
 {
   while (*txt)
      UART1_Write(*txt++);
}


void CRLF2()
{
 UART2_Write(CR);
 UART2_Write(LF);
}

void UART2_Write_CText(const char *txt)
 {
   while (*txt)
      UART2_Write(*txt++);
}



void Write_Msg_Eeprom(int Adr,const char * d1)
{ int i1 ,i;
  char c1;
  i1=Adr;
  do
  {
  c1=*d1;
  EEPROM_Write(Adr,c1); 
  if ( c1==0) break;
  if ( i1>1023) break;
  Delay_ms(5);
  i1++;
  }
  while (i!=0) ;
 }
 
void Read_Msg_Eeprom( int debut)
{   int i1 ,i;
  i1=debut;
  do
  {
  i = EEPROM_Read(i1);
  if ( i==0) break;
  if ( i1>1023) break;
  UART1_Write(i);
  Tampon[i1-debut]=i;
  Delay_ms(5);
  i1++;
   }
  while (i!=0) ;
 }

void Arme_Timer1()
{
   // 100mS * Max_Timer1
  TMR1IF_bit         = 0;
  TMR1H         = 0x0B;
  TMR1L         = 0xDC;
  Cpt1=0;
  Flag_Timer1=0;
  TMR1ON_bit=1;     // Timer0 ON
  TMR1IE_bit         = 1;
  }


void Init_Timer1(void)    
 {
  //Timer1
//Prescaler 1:4; TMR1 Preload = 3036; Actual Interrupt Time : 100 ms
//Place/Copy this part in declaration section
// 00 =Timer1/3/5 clock source is instruction clock (FOSC/4)
// 10 = 1:4 Prescale value  TxCKPS<1:0>
//  0 = Synchronize external clock input with system clock (FOSC)
//  0 = Dedicated Secondary oscillator circuit disabled
//  1   TxRD16: 16-Bit Read/Write Mode Enable bit
//  1    TMRxON: Timer1/3/5 On bit  1 = Enables Timer1/3/5
  T1CON         = 0x23;
  TMR1IF_bit         = 0;
  TMR1H         = 0x0B;
  TMR1L         = 0xDC;
  TMR1IP_bit=0;   // low level interrupt
  TMR1IE_bit         = 0;
  INTCON         = 0xC0;
  Cpt1=0;
  Flag_Timer1=0;
  Max_Timer1=40;
}

 


unsigned char *Float2Ascii (float x, unsigned char *str,char precision)
{
 /* converts a floating point number to an ascii string */
 /* x is stored into str, which should be at least 30 chars long */
 unsigned char *adpt;
 int ie, i, k, ndig;
 double y;
 adpt=str;
 ndig = ( precision<=0) ? 7 : (precision > 22 ? 23 : precision+1);
 ie = 0;
 /* if x negative, write minus and reverse */
 if ( x < 0)
 {
   *str++ = '-';
   x = -x;
 }
 /* put x in range 1 <= x < 10 */
 if (x > 0.0) while (x < 1.0)
 {
   x *= 10.0;                // a la place de =*
   ie--;
 }
 while (x >= 10.0)
 {
   x = x/10.0;
   ie++;
 }
 // in f format, number of digits is related to size
 ndig += ie;                                // a la place de =+
 //round. x is between 1 and 10 and ndig will be printed to
 // right of decimal point so rounding is ...
 for (y = i = 1; i < ndig; i++)
 y = y/10.;
 x += y/2.;
 if (x >= 10.0) {x = 1.0; ie++;}
 if (ie<0)
 {
   *str++ = '0'; *str++ = '.';
   if (ndig < 0) ie = ie-ndig;
   for (i = -1; i > ie; i--)  *str++ = '0';
 }
 for (i=0; i < ndig; i++)
 {
   k = x;
   *str++ = k + '0';
   if (i ==  ie ) *str++ = '.';
   x -= (y=k);
   x *= 10.0;
  }
 *str = '\0';
return (adpt);
}


void PrintHandler(char c)
 {
  UART1_Write(c);
}


 void Init_Hardware() 
{
  PORTB = 0xFF;
  TRISB = 0x83;    //  B0,B1 as input   ATTENTION B7 B6 for ICSP Pickit3
  ANSELB=0;

  PORTA = 0b00000011;
  ANSELA=0;
  ANSELA.ANSA0=1;    //  analog input on Port A   voir page 154
  ANSELA.ANSA1=1;
  TRISA = 0b00000011 ;   // PORTA is RA0,1= analog input  RA2=sortie DAC RA3,4,5=Digital output
  PORTA=0;

  PORTC = 0x00;          // RC0..RC5,RC7 = input RC6=Output
  ANSELC=0;
  TRISC = 0xFF;    //
  TRISC.TRISC7 = 1;  // RX - UART1
  TRISC.TRISC6 = 0;  // TX - UART1

  PORTD=0;
  ANSELD=0;
  TRISD=0xFF;
  TRISD.TRISD0 = 0;  // SCL I2C2
  TRISC.TRISD1 = 1;  // SDA I2C2
  TRISD.TRISD6 = 0;  // TX UART2
  TRISC.TRISD7 = 1;  // RX UART2

  SLRCON=0; // standard rate for PORTA,B,C,D,E
 }

void Init_ADC()
 {
       //config lecture ADC 10 bits
 ADCON0.ADON=1;      // ADC enabled chanel 0
 ADCON1.TRIGSEL=0 ; // trigger from CCP5
 ADCON2.ADFM=1;     // right justified
 ADCON2.ACQT2=1;
 ADCON2.ACQT1=1;
 ADCON2.ACQT0=0;    // 16 TAD
 ADCON2.ADCS1=1;    // select RA0 = analog input
 ADCON2.ADCS2=0;    // RA1 = Analog input
 ADCON2.ADCS0=0;    // Fosc/32
 ADCON1.PVCFG1=0;   // +Vref = +5V AVdd
 ADCON1.PVCFG0=0;
 ADCON1.NVCFG1=0;   // -Vref = Gnd AVss
 ADCON1.NVCFG0=0;
 }

void RAZ_UART1()
{
    for (i1=0;i1<MAXLEN1;i1++) buffer1[i1]=0;
    i1=0;
    Index1=0;
    c1=RC1REG;
    c1=0;
    Flag_Buffer1 =0;
    RC1IE_bit = 1;
}
void RAZ_UART2()
{
    for (i2=0;i2<MAXLEN2;i2++) buffer2[i2]=0;
    i2=0;
    Index2=0;
    c2=RC2REG;
    c2=0;
    Flag_Buffer2 =0;
    RC2IE_bit = 1;
}

char *  Send_Cde_Test_response(const char *cde,const char * answ)
{
char dummy[40];
int ix=0;
int n;  
  UART1_Write_CText(cde);CRLF1();
  strConstRamCpy(dummy,answ);
  n=strlen(dummy);
  RAZ_UART2();
  UART2_Write_CText(cde);
  Delay_ms(3500);
  //Arme_Timer1();
  //while (Flag_Timer1==0);
  p=strpbrk(dummy,buffer2);
  if (p>0 ) Step++;
  UART1_Write_Text(buffer2);
  CRLF1();
  CRam1[0]=0;
  p=&CRam1[0];
  ByteToStr(Step,CRam1);
  CRam1[8]=0;
  LCD_Write_Text_At(2,8,CRam1);
  return p;
  }


char *  Test_ReturnP ( unsigned char  j)
{
  CRam1[0]=0;
  p=&CRam1[0];
  Step=j;
  ByteToStr(Step,CRam1);
  LCD_Write_Text_At(2,8,CRam1);
  return p;
  }


 void WiFI_Configure()
 {
  Max_Timer1=40;
  RAZ_UART2();
  Step=0;
  UART1_Write_CText("Step 0 \r\n Connect to WIFI3 \r\n");
  p=Send_Cde_Test_response("AT\r\n","OK");
  Delay_ms(500);

  sprintf(txt," Step %s \r\n Reseting Module \r\n",p );
  UART1_Write_Text(txt);
  p=Send_Cde_Test_response("AT+RST\r\n","ready");
  Delay_ms(500);

  sprintf(txt,"Step %s \r\n Test si vitesse modifiable ? \r\n",p  );
  UART1_Write_Text(txt);
  p=   Send_Cde_Test_response("AT+CIOBAUD=19200\r\n","OK");
  Delay_ms(500);
  
  sprintf(txt," Step %s \r\n Version Module \r\n",p );
   //< number > version infoClengthF8 bytes
  UART1_Write_Text(txt);
  p=Send_Cde_Test_response("AT+GMR\r\n","ready");
  Delay_ms(500);

  sprintf(txt,"Step %p \r\n Setting Station & AP mode =3\r\n",p );
  UART1_Write_Text(txt);
  p=   Send_Cde_Test_response("AT+CWMODE=3\r\n","OK");
  Delay_ms(500);

  sprintf(txt,"Step %s \r\n Set Multiple connection : \r\n",p);
  UART1_Write_Text(txt);
  p=   Send_Cde_Test_response("AT+CIPMUX=1\r\n","OK");
  Delay_ms(500);

  sprintf(txt,"Step %s \r\n Reseaux visibles   :\r\n",p);
  UART1_Write_Text(txt);
  UART1_Write_CText("Attendre jusqu' 18 sec pour decouvrir tous les reseaux WIFI environnant !\r\n");
 //code ci dessous OK !
  UART1_Write_CText("AT+CWLAP\r\n");
  strConstRamCpy(CRam1,"OK");
  k=strlen(CRam1) ;
  CRLF1();
  RAZ_UART2();
  UART2_Write_CText("AT+CWLAP\r\n");
  // ok avec Delay donc sans IT
   Delay_ms(18000);
  // Bad avec timer1
  //Max_Timer1=180;
  //Arme_Timer1;
  //while (Flag_Timer1==0);
   Max_Timer1=40;
  UART1_Write_Text(buffer2);
  p=strpbrk(CRam1,buffer2);
  if (p>0 ) Step++;
  CRam1[0]=0;
  p=&CRam1[0];
  ByteToStr(Step,p);
  LCD_Write_Text_At(2,8,p);
  CRLF1();
  Delay_ms(500);
  Max_Timer1=40;


  sprintf(txt,"Step %s \r\n CIPSTART  \r\n",p );
  UART1_Write_Text(txt);
  p=  Send_Cde_Test_response("AT+CIPSTART=?\r\n","OK");
  Delay_ms(500);

  sprintf(txt,"Step %s \r\n Getting  Adresse IP \r\n",p );
  UART1_Write_Text(txt);
  p=   Send_Cde_Test_response("AT+CIFSR\r\n","OK");
  Delay_ms(500);

  sprintf(txt,"Step %s \r\n TimeOut Value ? \r\n",p );
  UART1_Write_Text(txt);
  p=   Send_Cde_Test_response("AT+CIPSTO?\r\n","OK");
  Delay_ms(500);

  sprintf(txt,"Step %s \r\n Set Connecting to AP \r\n",p);
  UART1_Write_Text(txt);
  p=   Send_Cde_Test_response("AT+CWSAP=\"ESP_9C100C\",\"\",4,0\r\n","OK");
  Delay_ms(500);

  sprintf(txt,"Step %s \r\n Set Server/port \r\n",p );
  UART1_Write_Text(txt);
  p=   Send_Cde_Test_response("AT+CIPSERVER=1,10001\r\n","OK");
  Delay_ms(500);


  //    A suivre
   sprintf(txt,"Step %c \r\n Station MAC adresse ?\r\n ",Step );
   UART1_Write_Text(txt);
   p=   Send_Cde_Test_response("AT+CIPSTAMAC?\r\n","OK");
  Delay_ms(500);

  sprintf(txt,"Step %c \r\n Adresse IP ? \r\n",Step );
  UART1_Write_Text(txt);
  p=   Send_Cde_Test_response("AT+CWLIF\r\n","OK");
  Delay_ms(500);
    
  sprintf(txt,"Step %s \r\n STATUS  :\r\n",p );
  UART1_Write_Text(txt);
  p=   Send_Cde_Test_response("AT+CIPSTATUS\r\n","OK");
  Delay_ms(1000);
}

void Re_Re_test()
{
  UART1_Write_Text("\r\n _Re_Re_test\r\n");
  Re_test();
}

void Re_test()
{
  UART1_Write_Text("\r\n Re_test\r\n");
  TEST();
}

void TEST()
{
UART1_Write_CText("delai 4sec \r\n");
    Max_Timer1=40;
   Arme_Timer1();
   while(Flag_Timer1==0);
    UART1_Write_CText("delai 15sec \r\n");
     Max_Timer1=150;
   Arme_Timer1();
   while(Flag_Timer1==0);
     UART1_Write_CText("Elapsed\r\n");


}


void main()
{
 Delay_ms(100);
 Init_Hardware() ;
 CH_PD_Direction=0;
 GPIO15_Direction=0;
 Max_Timer1=40;
 Vbray=0;

 Led_Rouge=0;

 UART1_Init(19200);
 Delay_ms(100);
 UART1_Write(CLS);   // Erase screen terminal  :it is an option on Vbray Terminal!
 Delay_ms(500);
  j=0;
 l=0;
 CRLF1();
 UART1_Write_CText("Init UART1 19200 bds\r\n");

 UART2_Init(19200);
 Delay_ms(500);
 j=0;
 l=0;
 txt=&TEXTE[0];
 UART1_Write_CText("Init UART2 19200 bds\r\n");
 Led_Rouge=1;
 Delay_ms(1000);

  // presentation sur UART
  UART1_Write_CText ("Presentation : \r\n");
 // strConstRamCpy(txt, mesg0);
 //UART1_Write_Text(txt);
 // Read_Msg_Eeprom(0x00);
 // Read_Msg_Eeprom(0x20);
 // Read_Msg_Eeprom(0x40);
  UART1_Write_CText("Projet : WIFI3_18F46k22_UART1_LCD2119_3_3V.mcppi \r\n");
  UART1_Write_CText("Version : "Version"\r\n");

 // Read_Msg_Eeprom(0x60);
  txt=&TEXTE[0];
  UART1_Write_CText("\r\nInit I2C1 at 400Khz\r\n");
  Led_Rouge=1;
  Led_Rouge=0;
  I2C1_Init(400000);
  CRLF1();

  addr=LCD_ADR;
  k=check_device(addr)  ;
  CRLF1();
   UART1_Write_CText("Init LCD 2119\r\n");
  k=LCD2119_Init();
  Delay_ms(50);
  LCD_CLS();
  Delay_ms(50);

  // Presentation sur LCD
  // LCD_RAZ_Ligne(1);
   LCD_Write_CText_At(1,1,"18F46K22 Q=10MHz");
   LCD_Write_CText_At(2,1,"Version I2C400Kz");
   Delay_ms(1500);  // sans ce delai ,les 3 premiers caracteres sont bouffes sur le LCD
   LCD_Write_CText_At(1,1,"MikroC 6.62 1603");
   LCD_RAZ_Ligne(2);
  Delay_ms(2000);
  CRLF1();

   Max_Timer1=40;
   UART1_Write_CText("Init Timer1 100msec\r\n" );
   Init_Timer1();

  RC2IE_bit=1 ;
  RC1IE_bit=1 ;
  RC1IP_bit=1;
  RC2IP_bit=1;
  TMR1IP_bit=0;
  PEIE_bit=1;
  RCON.IPEN = 1;       // enable priority levels  , car TMR1 => low interrupt
  PEIE_bit = 1;          // Enable Peripheral interrupt
  GIE_bit  = 1;         // Enable Global interrupt

 //   TEST IT TIMER1 ci dessous .. OK !
  /*
  do
  {
  Re_Re_test();
  }
   while(1);
  */
   
  Led_Rouge=1;
  Init_ADC(); 

  j=0;
  txt=&TEXTE[0];
  
  LCD_Write_CText_At(1,1," POWER ON Wifi3 ");
  UART1_Write_CText("Init Wifi3 Power ON 5sec.\r\n" );
  // Reset  WIFI3
  CH_PD=0;
  GPIO15=1;
  // verif Horloge FOSC via Delai et application delai pour POWER ON WIFI3
  CRLF1();
  UART1_Write('#');
  CRLF1();
  LCD_Write_CText_At(2,1,"Decompte :  5/5 ");
  for (i=0;i<5;i++)
  {
  Delay_ms(1000);
  LCD_Write_Chr_At(2,13,53-i);
   }
  CRLF1(); 
  UART1_Write('$');
  CRLF1(); 
  CH_PD= 1;
  GPIO15=1;
  RAZ_UART2();
  RAZ_UART1();

  SEAn0 =0;
  SEAn1=0;
  nM=0; 
  
  Max_Timer1=40;
  UART1_Write_CText("Init Timer1 100msec\r\n" );
  Init_Timer1();
  
  RC2IE_bit=1 ;
  RC1IE_bit=1 ;
  RC1IP_bit=1;
  RC2IP_bit=1;
  TMR1IP_bit=0;
  PEIE_bit=1;
  RCON.IPEN = 1;       // enable priority levels  , car TMR1 => low interrupt
  PEIE_bit = 1;          // Enable Peripheral interrupt
  GIE_bit  = 1;         // Enable Global interrupt


  
  // Configure WiFI module
  LCD_Write_CText_At(1,1,"Wifi3 Configure ");
  LCD_Write_CText_At(2,1," Step           ");
  UART1_Write_CText("Wifi3 Configure via UART2\r\n" );
  

  UART1_Write_CText("Armement et init Max_Timer1  4sec\r\n" );
  
  WiFI_Configure();
  

  RAZ_UART1();
  RAZ_UART2();
  Vbray=1;
  
  //---- main boucle ------------------
  do
  {
  // TMR0ON_bit=1;
  // TMR0IE_bit=1;
   WordToStr(nM,CRam1);
   CRam1[6]=0;
   LCD_Write_Text_At(1,10,CRam1);
   Delay_ms(1000);

   EAn0= ADC_Get_Sample(0);
   f1=(float)EAn0 * 0.0048828;
   p=Float2Ascii (f1,CRam1,2);
   LCD_Write_CText_At(1,1,"EA0= ");
   CRam1[16]=0;
   LCD_Write_Text_At(1,6,CRam1);
   SEAn0=SEAn0+EAn0;
   
   EAn1= ADC_Get_Sample(1);
   f2=(float)EAn1 * 0.0048828;
   p=Float2Ascii (f2,CRam1,2);
   LCD_Write_CText_At(2,1,"EA1= ");
   CRam1[16]=0;
   LCD_Write_Text_At(2,6,CRam1);

   SEAn1=SEAn1+EAn1;
   nM++;
   txt=TEXTE;
   sprintf(txt,"  EAn0=% 4.3f V    EAn1=% 4.3f V nM=%03d  \r\n",f1,f2,nM);
   UART1_Write_Text(txt);
   // moyenne de 10 samples
    if (nM %10==0)
     {
       f1= (float)SEAn0 * 0.00048828;
       f2= (float)SEAn1  * 0.00048828;
       SEAn0 =0;
       SEAn1=0;   
       txt=TEXTE; 
       //time[6]=0; 
       sprintf(txt, " E0=% 4.3fV;E1=% 4.3fV\n\r",f1,f2);
       k=strlen(txt);
       UART1_Write_Text(txt);
       
       LCD_RAZ_Ligne(1);
       p=Float2Ascii (f1,CRam1,2);
       LCD_Write_CText_At(1,1,"Moy0= ");
       CRam1[16]=0;
       LCD_Write_Text_At(1,6,CRam1);
       
       LCD_RAZ_Ligne(2);
       p=Float2Ascii (f2,CRam1,2);
       LCD_Write_CText_At(2,1,"Moy1= ");
       CRam1[16]=0;
       LCD_Write_Text_At(2,6,CRam1);
     }
     
    // boucle d'attente

    Arme_Timer1();
    while (Flag_Timer1==0);


    if ( Flag_Buffer1==1)
     {  

       UART1_Write_CText("Recu  : ");
       CRLF1();UART1_Write_Text(buffer1); CRLF1();
       LCD_Write_CText_At(1,1,"Reception UART1 ");
       UART2_Write_Text(buffer1);
       buffer1[16]=0;   // limit  20 chars for LCD !
       Delay_ms(2000);
       LCD_Write_Text_At(2,1,buffer2);
       UART1_Write_Text(buffer2);
       CRLF1();
        RAZ_UART1();
        RAZ_UART2();
     }
     Led_Rouge=!Led_Rouge;  // alive led !

   }
   while(1); // end loop
 }
    
    
    
/*
Lynksys PC XP
On_Air_2016
WEP128b = 3ABOQPHIE/3PIR2=3QBC
ESP_9C100C   1A-FE-34-9C-10-0C


Resultat sur terminal Vbray

  */